#include <stdio.h>
#include <getopt.h>
#include <sys/types.h>
#include <pwd.h>
#include <shadow.h>
#include <stdlib.h>

struct spwd *getspnam(const char *name);

int main (int argc, char *argv[]){

	struct passwd *p;
	struct spwd *s;

        if (argc < 2) {
            printf("%s <username> [uid]\n", argv[0]);
            return -1;
        }

	if (!(p=getpwnam(argv[1]))) {
                printf("getpwnam %s returned NULL\n", argv[1]);
	} else {
	
                printf("getpwnam %s PASSWORD:\n", argv[1]);

                printf("\tname:  %s\n", p->pw_name);
                printf("\tdir:   %s\n", p->pw_dir);
                printf("\tgecos: %s\n", p->pw_gecos);
        }

	if (!(s = getspnam(argv[1]))) {
                printf("getspnam %s returned NULL\n", argv[1]);
	} else {
                printf("%s SHADOW:\n", argv[1]);
                printf ("\tname:  %s\n", s->sp_namp);
                printf ("\tpass:  %s\n", s->sp_pwdp);
        }
        if( argc == 3 ) {
                if(!(p=getpwuid(atoi(argv[2])))) {
                        printf("getpwuid(%i) returned NULL\n", atoi(argv[2]));
                } else {
                        printf("getpwuid(%i) PASSWORD:\n", atoi(argv[2]));

                        printf("\tname:  %s\n", p->pw_name);
                        printf("\tdir:   %s\n", p->pw_dir);
                        printf("\tgecos: %s\n", p->pw_gecos);
                }
        }
	return 0;
}
